using ICSSoft.Common;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ICSSoft.Entity;
using UFSoft.UBF.Util.Context;
using System.ServiceModel;
using www.ufida.org.EntityData;
using UFSoft.UBF.Exceptions1;
using UFSoft.UBF.Service;
using ICS.WCF.Base;

namespace ICSSoft.APIApproveTransferIN
{
    public class ApproveTransferIN
    {
        private static log4net.ILog log = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        private static string connString = System.Configuration.ConfigurationManager.AppSettings["ERPConnStr"];
        private static string ERPDB = System.Configuration.ConfigurationManager.AppSettings["ERPDB"];
        /// <summary>
        /// 审核一步式调入单（外部通过API调用）
        /// </summary>
        /// <param name="infos"></param>
        /// <returns></returns>
        public Result Approve(List<ICSTransferDoc> infos)
        {
            var res = new Result();
            var datalist = new List<ICSTransferDoc>();

            foreach (var info in infos)
            {
                try
                {
                    UFIDAU9ISVTransferInISVITransferInBatchApproveSRVClient client = new UFIDAU9ISVTransferInISVITransferInBatchApproveSRVClient();
                    MessageBase[] returnMsg;
                    //上下文信息
                    object context;
                    //传入 参数


                    string OrgID = "";
                    string orgsql = @"select ID from Base_Organization
                                  where Code='{0}'";
                    orgsql = string.Format(orgsql, info.WorkPoint);
                    DataTable orgdt = DBhlper.Query(orgsql, Appconfig.GetU9ConnStr());
                    if (orgdt.Rows.Count != 0)
                    {
                        OrgID = orgdt.Rows[0]["ID"].ToString();
                    }
                    else
                    {
                        throw new Exception("传入组织编码错误!");
                    }

                    var UserID = "";
                    var UserCode = "";
                    var UserName = "";
                    string sql = "select ID,Name from Base_User where Code ='" + info.User + "'";
                    DataTable dt = DBhlper.Query(sql, Appconfig.GetU9ConnStr());
                    if (dt.Rows.Count != 0)
                    {
                        UserID = dt.Rows[0]["ID"].ToString();
                        UserCode = info.User;
                        UserName = dt.Rows[0]["Name"].ToString();
                    }
                    else
                    {
                        sql = "select ID,Name from Base_User where Code ='" + Appconfig.GetDefaultUser() + "'";
                        dt = DBhlper.Query(sql, Appconfig.GetU9ConnStr());
                        if (dt.Rows.Count != 0)
                        {
                            UserID = dt.Rows[0]["ID"].ToString();
                            UserCode = Appconfig.GetDefaultUser();
                            UserName = dt.Rows[0]["Name"].ToString();
                        }
                        else
                        {
                            throw new Exception("传入用户编码错误!");
                        }

                    }

                    //给上下文信息赋值
                    context = CreateContextObj(OrgID, UserID, UserCode);
                    //给传入参数赋值


                    //服务调用
                    (client.Endpoint.Binding as BasicHttpBinding).MaxReceivedMessageSize = int.MaxValue;
                    (client.Endpoint.Binding as BasicHttpBinding).MaxBufferSize = int.MaxValue;

                    UFIDAU9CBOPubControllerCommonArchiveDataDTOData[] queryArr = new UFIDAU9CBOPubControllerCommonArchiveDataDTOData[] { };
                    List<UFIDAU9CBOPubControllerCommonArchiveDataDTOData> queryList = new List<UFIDAU9CBOPubControllerCommonArchiveDataDTOData>();
                    UFIDAU9CBOPubControllerCommonArchiveDataDTOData q = new UFIDAU9CBOPubControllerCommonArchiveDataDTOData();

                    string DocNo = "";
                    sql = @"SELECT DocNO FROM InvDoc_TransferIn a WHERE a.ID='" + info.ID + "'";
                    dt = DBhlper.Query(sql, Appconfig.GetU9ConnStr());
                    if (dt.Rows.Count > 0)
                    {
                        DocNo = dt.Rows[0]["DocNO"].ToString();
                    }
                    else
                    {
                        throw new Exception("传入单据ID有误，请确认！");
                    }
                    q.m_iD = long.Parse(info.ID);
                    q.m_code = DocNo;
                    queryList.Add(q);

                    queryArr = queryList.ToArray();

                    returnMsg = client.Do(context, queryArr, infos[0].User, DateTime.Now);
                    if (returnMsg != null && returnMsg.Length > 0)
                    {
                        foreach (var item in returnMsg)
                        {
                            throw new Exception(item.localMessage);
                        }
                    }



                    #region 审核后修改单据审核人

                    var usersql = @"update InvDoc_TransferIn set ApprovedBy='{0}',ModifiedBy='{0}'
                                where ID='{1}'
                                update InvDoc_TransInLine set ModifiedBy='{0}'
                                where TransferIn='{1}'";
                    usersql = string.Format(usersql, UserName, info.ID);
                    DBhlper.Query(usersql, Appconfig.GetU9ConnStr());


                    var linelist = new List<ICSTransferLineDoc>();
                    foreach (var item in info.details)
                    {
                        linelist.Add(new ICSTransferLineDoc
                        {
                            DetailID = item.DetailID,
                            LogIds = item.LogIds,
                            IsSuccess = true,
                            Message = "成功"
                        });
                    }

                    datalist.Add(new ICSTransferDoc
                    {
                        ID = info.ID,
                        IsSuccess = true,
                        Message = "成功",
                        details = linelist
                    });

                    #endregion
                }
                catch (Exception ex)
                {
                    var linelist = new List<ICSTransferLineDoc>();
                    foreach (var item in info.details)
                    {
                        linelist.Add(new ICSTransferLineDoc
                        {
                            DetailID = item.DetailID,
                            LogIds = item.LogIds,
                            IsSuccess = false,
                            Message = "异常：" + GetExceptionMessage(ex)
                        });
                    }

                    datalist.Add(new ICSTransferDoc
                    {
                        ID = info.ID,
                        IsSuccess = false,
                        Message = "异常：" + GetExceptionMessage(ex),
                        details = linelist
                    });
                }
            }

            res.Success = true;
            res.Message = "成功";
            res.Data = datalist;


            return res;

        }
        /// <summary>
        /// 审核一步式调入单（接口内部调用，如：创建退料单后调用审核单据）
        /// </summary>
        /// <param name="DocNOList"></param>
        /// <param name="OrgCode"></param>
        /// <returns></returns>
        public bool Approve(List<string> DocIDList, string OrgCode, string UserCode)
        {
            bool ResultFlag = false;
            UFIDAU9ISVTransferInISVITransferInBatchApproveSRVClient client = new UFIDAU9ISVTransferInISVITransferInBatchApproveSRVClient();
            MessageBase[] returnMsg;
            //上下文信息
            object context;
            //传入 参数
            try
            {
                if (DocIDList == null || DocIDList.Count == 0)
                {
                    throw new Exception("传入数据不能为空!");
                }
                string OrgID = "";
                string orgsql = @"select ID from Base_Organization
                                  where Code='{0}'";
                orgsql = string.Format(orgsql, OrgCode);
                DataTable orgdt = DBhlper.Query(orgsql, Appconfig.GetU9ConnStr());
                if (orgdt.Rows.Count != 0)
                {
                    OrgID = orgdt.Rows[0]["ID"].ToString();
                }
                else
                {
                    throw new Exception("传入组织编码错误!");
                }

                //给上下文信息赋值
                context = CreateContextObj(OrgID, "", "");
                //给传入参数赋值


                //服务调用
                (client.Endpoint.Binding as BasicHttpBinding).MaxReceivedMessageSize = int.MaxValue;
                (client.Endpoint.Binding as BasicHttpBinding).MaxBufferSize = int.MaxValue;

                UFIDAU9CBOPubControllerCommonArchiveDataDTOData[] queryArr = new UFIDAU9CBOPubControllerCommonArchiveDataDTOData[] { };
                List<UFIDAU9CBOPubControllerCommonArchiveDataDTOData> queryList = new List<UFIDAU9CBOPubControllerCommonArchiveDataDTOData>();
                UFIDAU9CBOPubControllerCommonArchiveDataDTOData q = new UFIDAU9CBOPubControllerCommonArchiveDataDTOData();
                foreach (string ID in DocIDList)
                {
                    string DocNo = "";
                    string sql = @"SELECT DocNO FROM InvDoc_TransferIn a WHERE a.ID='" + ID + "' AND Org='" + OrgID + "'";
                    DataTable dt = DBhlper.Query(sql, Appconfig.GetU9ConnStr());
                    if (dt != null && dt.Rows.Count > 0)
                    {
                        string a = dt.Rows[0][0].ToString();
                        if (string.IsNullOrWhiteSpace(a))
                        {
                            throw new Exception("传入单据ID有误，请确认！");
                        }
                        else
                        {
                            DocNo = a;
                        }
                    }
                    else
                    {
                        throw new Exception("传入单据ID有误，请确认！");
                    }
                    q.m_iD = long.Parse(ID);
                    q.m_code = DocNo;
                    queryList.Add(q);
                }
                queryArr = queryList.ToArray();

                returnMsg = client.Do(context, queryArr, UserCode, DateTime.Now);
                if (returnMsg != null && returnMsg.Length > 0)
                {
                    foreach (var item in returnMsg)
                    {
                        throw new Exception(item.localMessage);
                    }
                }
                else
                {
                    ResultFlag = true;
                }
            }
            catch (Exception ex)
            {
                log.Error(GetExceptionMessage(ex));
                throw new Exception(GetExceptionMessage(ex));
            }
            return ResultFlag;
        }

        #region 给上下文信息赋值
        /// <summary>
        /// 给上下文信息赋值
        /// </summary>
        /// <returns></returns>
        private static ThreadContext CreateContextObj(string OrgID, string UserID, string UserCode)
        {
            // 实例化应用上下文对象
            ThreadContext thContext = new ThreadContext();


            System.Collections.Generic.Dictionary<object, object> ns = new Dictionary<object, object>();
            ns.Add("OrgID", OrgID);
            ns.Add("UserID", UserID);
            ns.Add("UserCode", UserCode);
            ns.Add("Datetime", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"));
            ns.Add("CultureName", ConfigurationManager.AppSettings["cultureName"].ToString());
            ns.Add("EnterpriseID", ConfigurationManager.AppSettings["enterpriseID"].ToString());
            ns.Add("DefaultCultureName", ConfigurationManager.AppSettings["cultureName"].ToString());
            thContext.nameValueHas = ns;

            return thContext;
        }
        #endregion

        #region 提取异常信息
        /// <summary>
        /// 提取异常信息
        /// </summary>
        /// <param name="ex"></param>
        private string GetExceptionMessage(Exception ex)
        {
            string faultMessage = "未知错误，请查看ERP日志！";

            System.TimeoutException timeoutEx = ex as System.TimeoutException;
            if (timeoutEx != null)
            {
                faultMessage = "访问服务超时，请修改配置信息！";
            }
            else
            {
                FaultException<ServiceException> faultEx = ex as FaultException<ServiceException>;
                if (faultEx == null)
                {
                    faultMessage = ex.Message;
                }
                else
                {
                    ServiceException serviceEx = faultEx.Detail;
                    if (serviceEx != null && !string.IsNullOrEmpty(serviceEx.Message)
                        && !serviceEx.Message.Equals("fault", StringComparison.OrdinalIgnoreCase))
                    {
                        // 错误信息在faultEx.Message中，请提取，
                        // 格式为"Fault:料品不能为空，请录入\n 在....."
                        int startIndex = serviceEx.Message.IndexOf(":");
                        int endIndex = serviceEx.Message.IndexOf("\n");
                        if (endIndex == -1)
                            endIndex = serviceEx.Message.Length;
                        if (endIndex > 0 && endIndex > startIndex + 1)
                        {
                            faultMessage = serviceEx.Message.Substring(startIndex + 1, endIndex - startIndex - 1);
                        }
                        else
                        {
                            faultMessage = serviceEx.Message;
                        }
                    }
                }
            }
            return faultMessage;
        }
        #endregion
    }
}
